﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'About Class module by DavideV 2014
'show an about web page
'require AHLocale library and almost a default en.html file in files tab
'require also all elements displayed in the web page (put them in files tab)

Sub Class_Globals
	'Private Pkg 			As String		'the event that handle the result
	Private Act 			As activity		'the activity that use this class
	Private Target			As Object		'the module that is using this class
	Private Event 			As String		'the event name in the called module
	Private WebPage 		As WebView		'about webpage
	Private WebPanel		As Panel		'support panel
	Private IsShow			As Boolean		'about page showing or not flag
	Private LocISOcode 		As String		'contains the ISO code from AHLocale
	Private MyAppVideo		As String		'contains the link to video
	Private MyAppName		As String
	Private	MyAppVersion	As String
	Private MyAppRegcode    As String		'app reg code if available
	Private MyAppStoreLink  As String		'link to the app store for this app
	Private MyAppChangeLog  As List			'changelog string list
	Private PrefChangeLog   As String		'changelog string compiled for html
	
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(TargetModule As Object ,EventName As String, TargetActivity As activity, Package As String)
	Target=TargetModule
	Event=EventName
	Act=TargetActivity
	WebPage.Initialize("WebPage")
	WebPanel.Initialize("")
	
	Dim Loc	As AHLocale		'the locale library
	Loc.Initialize
	LocISOcode=Loc.ISOCode	'get the iso code used to load correct html page
	
	'set app label & version
	MyAppVersion=Application.VersionName
	MyAppName=Application.LabelName
	
	'set default values
	MyAppVideo=""						'default value
	MyAppRegcode="Not available"		'default value
	MyAppStoreLink=""					'default value
	'MyAppChangeLog.Initialize
	'MyAppChangeLog.Add("No changelog available")
	PrefChangeLog="No changelog available"	'default value
	
	IsShow=False
	

End Sub

Public Sub SetAppStore(AppStore As String)
	'set the app store link for this app, must be a valid link
	If AppStore="" Then
		MyAppStoreLink=""
	Else
		MyAppStoreLink="<p align=""center"">" & AppStore & "<br>" & "View on the app store and , If you like this app, rate it :)</p>"
	End If
	
End Sub

Public Sub SetAppVideo(AppVideo As String)
	'set the video url of the app, must be a valid link
	If AppVideo="" Then
		'no video
		MyAppVideo=""
	Else
		'center the video string in html code
		MyAppVideo="<p align=""center""><a href=""" & AppVideo & """>video</a></p>"
	End If
		
End Sub

Public Sub SetAppRegCode(AppRegCode As String)
	'set the app registration code
	If AppRegCode="" Then
		'not available
		MyAppRegcode="Not available"
	Else
		MyAppRegcode=AppRegCode
	End If

End Sub

Public Sub SetAppChangeLog(AppChangeLog As List)
	'set and format the changelog
	If AppChangeLog.Size=0 Then Return	'don't add any string
	'continue
	MyAppChangeLog.Initialize
	PrefChangeLog=""
	For Each St As String In AppChangeLog
		PrefChangeLog=PrefChangeLog & St & "<BR>"
	Next	

End Sub

Public Sub LoadPage
	'show the About... page in html format
	'replace strings:
	'myappname 		= app name
	'myappversion 	= app version
	'PrefChangeLog	= app changelog
	'myappregcode	= app registration code
	'myappvideo		= app video on youtube
	'myappstorelink = app store link for this app
	
	WebPage.RemoveView	'to be sure is not already displayed on this parent	
	WebPanel.RemoveView
	
	Act.AddView(WebPanel,0,0,100%x,100%y)
	WebPanel.AddView(WebPage,0,0,100%x,100%y)
	
	Dim AboutFile 		As String			'language specific 'about' html file
	Dim HtmlCode  		As String			'contains the html modified code
					
	'get the correct html about file
	AboutFile="about/" & LocISOcode.SubString2(0,2) & ".html"		
	Log("About class required locale file: " & AboutFile)
	Try
		HtmlCode=File.ReadString(File.DirAssets , AboutFile)
	Catch
		Log("About file error: " & LastException)
		AboutFile="about/en.html"
		HtmlCode=File.ReadString(File.DirAssets , AboutFile)		
	End Try
	Log("About class using locale file: " & AboutFile)
	
	'load the html into a string then add the request code for registration
	'HtmlCode=File.ReadString(File.DirAssets , AboutFile)
	HtmlCode=HtmlCode.Replace("<!--$BASE$-->","<base href=""file:///android_asset/about/"" />")	'replace base folder for html embedded files
	HtmlCode=HtmlCode.Replace("myappname",MyAppName)			'set the app name
	HtmlCode=HtmlCode.Replace("myappversion",MyAppVersion)		'set the app vewrsion
	HtmlCode=HtmlCode.Replace("myappregcode",MyAppRegcode)		'set the registration code
	HtmlCode=HtmlCode.Replace("myappvideo",MyAppVideo)			'set the video link
	HtmlCode=HtmlCode.Replace("myappstorelink",MyAppStoreLink)	'set the app store link
	HtmlCode=HtmlCode.Replace("myappchangelog",PrefChangeLog)	'set the changelog
		
	WebPage.LoadHtml(HtmlCode)	
	IsShow=True	
	
End Sub

Public Sub UnloadPage
	'remove the about page
	WebPage.RemoveView		'remove the page
	WebPanel.RemoveView
	IsShow=False			'set as not showing
		
End Sub

Public Sub IsShowing As Boolean
	'return the visibility of the page:
	'true= loaded
	'false= not loaded or unloaded
	Return IsShow

End Sub

Private Sub WebPage_OverrideUrl (Url As String) As Boolean
	'pass the url to the calling module
	'return false to continue handling the url in browser else return true
	
	If SubExists(Target, Event & "_ClickedUrl") Then
		'call the handler if exist
		'if the handler return false then continue opening the url
		'if the handler return true then does nothing!
		Return CallSub2(Target, Event & "_ClickedUrl", Url)
	Else 
		'handle here if sub not found
		'let the user choose his preferred app if possible
		'otherwise open the link in browser
		ProgressDialogShow("Redirecting to" & CRLF & Url & "...")
		Dim i As Intent
		i.Initialize(i.ACTION_VIEW,Url)
		'i.SetComponent("")					'not used let the device/user select proper app
		'i.WrapAsIntentChooser("")
		Try
			'search for an app to do the task in this device
			StartActivity(i)
			Return True
		Catch
			'open in browser if no activities
			Log("DV About class error: " & LastException.Message)
			Return False			
		End Try
		
	End If
	
	
End Sub

Private Sub WebPage_PageFinished (Url As String)
	ProgressDialogHide
	
End Sub

'Changelog
'V2.00 2015/04/03
'new web pages
'fix for displaying on android 5.0 

'V1.00
'first release